/* Turn intelligent calc off */
set updatecalc off;

RUNJAVA com.hyperion.essbase.cdf.export.AddLine "file" "c:/flatdec.txt" "Sales	Actual";
RUNJAVA com.hyperion.essbase.cdf.export.AddLine "file" "c:/flatdec.txt" "Jan	Feb	Mar	Apr	May	Jun	July	Aug Sep	Oct	Nov	Dec";

/* Fix on Actual so that only one scenario is evaluated, otherwise a record for each scenario will be written and duplicated in the export */
Fix ( sales,dec)	

       actual(         

            IF ("variance" < 0)   
			
		   /* 
		  *    Export to a text file
		  *   arg 1:  specify "file" to export to a text file
		  *   arg 2:  file name.  This file name must be used to close the file after the calculation completes
		  *   arg 3:  delimiter.  Accepts "tab" for tab delimited.
		  *   arg 4:  text qualifier. Accepts "quotes" for " qualifier.
		  *   arg 5:  leave blank when exporting to text files
		  *   arg 6:  an array of member names (Use "" if you are not exporting members names)
		  *   arg 7:  an array of data (Use 0 if you are not exporting Data values)
		  *   arg 8:  an array of int values that sets decimal points per column (use -1 to return the stored number).  Use a comma seperated list to control every column differently: @LIST(2,3,4).
  		  *   arg 9:  an array of String values that replaces #Missing per column ( #Missing can be replaced with any text or a number such as "0").  Use a comma seperated list to control every column differently: @LIST("0","#Miss").
		  */
		   @JExtendedExportTo("file","c:/flatdec.txt","tab","quotes","",@List(@NAME(@currmbr(Market)),@NAME(@currmbr(Product))), @LEVMBRS (Year,0),@LIST(2),@list("#Mi") ) ;     
        	 
		
             ENDIF; 
               
	)
        
EndFix;
/*
*
*	Clean up
*
*/
/*Close the file*/
RUNJAVA com.hyperion.essbase.cdf.export.CloseTarget "file" "c:/flatdec.txt" "c:/flatdecDouble.txt" "c:/flatdecString.txt" ;
