package com.hyperion.essbase.cdf.export;

/**
 * Title:        SortRecords
 * Description:
 * Copyright:
 * Company:      Hyperion Solutions
 * @author:      Toufic Wakim
 * @version 2.0
 * Disclaimer: use provided functions at your own risk. Hyperion Solutions Corp. is not liable for any
  damage, direct or indirect, associated with the use of the supplied functions.
 */


import java.util.*;

public class SortRecords implements Comparable {
    public double[] values;
    public String[] members;
    public static final int data=0;
    public static final int memberName=1;
    public static final int ASC_ORDER=1;
    public static final int DESC_ORDER=-1;
    private  int sortWhat=0;
    private  int colNum=0;
    public  int sortOrder=1;


    public Double getValueToSort() {
        return new Double(getValue());
    }

    public double getValue(){
            return values[colNum];
    }

    public String getMemberName() {return members[colNum];}


    public SortRecords(String[] members, double[] values,int fieldNum, int order) {
        this.members  =members;
        this.values =values;
        this.sortOrder=order;

        if (  fieldNum >members.length && (fieldNum -members.length)<=values.length){
              this.colNum=fieldNum-members.length-1;
              this.sortWhat=SortRecords.data ;
         }  else if (fieldNum==0 ||(fieldNum -members.length)> values.length) {
              this.colNum =0;
              this.sortWhat=SortRecords.memberName;
         }  else {
              this.colNum=fieldNum-1;
              this.sortWhat=SortRecords.memberName;
         }

    }
public SortRecords() {


    }
    public int compareTo(Object o) {
        SortRecords n = (SortRecords)o;
        int lastCmp=0;

        if (this.sortWhat==data) {
              lastCmp = this.sortOrder * getValueToSort().compareTo(n.getValueToSort());
        } else {

              lastCmp = this.sortOrder *  getMemberName().compareTo(n.getMemberName());
        }

                return lastCmp;

    }


    public  SortRecords[] sortThis(SortRecords[] n) {


        if (n !=null && n[0].colNum >=0) {
              if(n[0].values != null) {


                    List l = Arrays.asList(n);
                    Collections.sort(l);
                    return (SortRecords[])l.toArray() ;

              }
        }
        return n;


    }

   public static void main(com.hyperion.essbase.calculator.Context ctx,String[] args) {

                if (args.length == 4)
                	ExportTo.sortRecords(args[1],args[2],args[3],"",new int[] {-1},new String[] {""});
				else if (args.length == 5)
					ExportTo.sortRecords(args[1],args[2],args[3],args[4],new int[] {-1},new String[] {""});
				else if (args.length == 6)
					ExportTo.sortRecords(args[1],args[2],args[3],args[4],AddLine.stringTointArray(args[5],","),new String[] {""});
				else if (args.length == 7)
					ExportTo.sortRecords(args[1],args[2],args[3],args[4],AddLine.stringTointArray(args[5],","),AddLine.stringToStringArray(args[6],","));
     }
    
    public static void debug(String s) {System.out.println("**DEBUG***" + s);}
}
